#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>

using namespace std;

struct coord
{
	int row;
	int col;
	coord()
	{
		row = -1;
		col = -1;
	}
};

struct animal
{
	int position;
	vector< vector<int> > shape;
	int rows, cols;
	int force;
	int minSafety;
	animal(int r, int c, int k, int t, int p)
	{
		rows = r;
		cols = c;
		force = k;
		minSafety = t;
		position = p;
	}
};

void input(int& N, int& M, int& P, vector< vector<int> >& field, vector<animal>& animals)
{
	ifstream parashIn;
	parashIn.open("parash.in", ios::in);

	parashIn >> N >> M >> P;

	for(int i = 0; i < N; i++)
    {
		vector<int> fieldRow;
        for(int k = 0; k < M; k++)
        {
			int fieldValue;
            parashIn >> fieldValue;
			fieldRow.push_back(fieldValue);
        }
		field.push_back(fieldRow);
		fieldRow.clear();
    }

	char* line = new char[50];
    for(int i = 0; i < P; i++)
    {
		int r, c, k, t;

        parashIn >> r >> c >> k >> t;
		animal tempAnimal(r, c, k, t, i + 1);
		animals.push_back(tempAnimal);
		for(int j = 0; j < r; j++)
		{
			vector<int> shapeRow;
			parashIn >> line;
			for(int z = 0; z < c; z++)
			{
				int boolValue = (line[z] == '1') ? 1 : 0;
				shapeRow.push_back(boolValue);
			}
			animals[i].shape.push_back(shapeRow);
			shapeRow.clear();
		}
    }
	delete [] line;
}

bool sortByForce(animal& animal1, animal& animal2)
{
	int i, j, animal1Ones = 0, animal2Ones = 0;
	for(i = 0; i < animal1.rows; i++)
	{
		for(j = 0; j < animal1.cols; j++)
		{
			if(animal1.shape[i][j] == 1) animal1Ones++;
		}
	}
	for(i = 0; i < animal2.rows; i++)
	{
		for(j = 0; j < animal2.cols; j++)
		{
			if(animal2.shape[i][j] == 1) animal2Ones++;
		}
	}
	return (animal1.minSafety + animal1.force - animal1Ones) < (animal2.minSafety + animal2.force - animal2Ones); 
}

coord checkCoords(animal& curAnimal, vector< vector<int> >& field, int N, int M)
{
	int sum = 0, maxSum = 0;
	coord topLeft = coord();
	int i, k, j, l;
	for(i = 0; i <= N - curAnimal.rows; i++)
	{
		for(k = 0; k <= M - curAnimal.cols; k++)
		{
			for(j = 0; j < curAnimal.rows; j++)
			{
				for(l = 0; l < curAnimal.cols; l++)
				{
					if(curAnimal.shape[j][l] == 1 && field[i + j][k + l] < curAnimal.minSafety)
					{
						break;
					}
					if(curAnimal.shape[j][l] == 1)
					{
						sum += field[i + j][k + l];
					}
				}
				if(l != curAnimal.cols)
				{
					sum = 0;
					break;
				}
			}
			if(sum > maxSum)
			{
				maxSum = sum;
				topLeft.row = i;
				topLeft.col = k;
			}
			sum = 0;
		}
	}
	return topLeft;
}

void placeAnimal(coord coords, animal& curAnimal, vector< vector<int> >& field)
{
	for(int i = 0; i < curAnimal.rows; i++)
	{
		for(int k = 0; k < curAnimal.cols; k++)
		{
			if(curAnimal.shape[i][k] == 1)
			{
				field[i + coords.row][k + coords.col] /= curAnimal.force;
			}
		}
	}
}

int main()
{
	int M, N, P, animalsJumped = 0;
	vector<coord> jumperCoords;
	vector<int> jumperPosition;
	vector< vector<int> > field;
	vector<animal> animals;

    input(N, M, P, field, animals);

	sort(animals.begin(), animals.end(), &sortByForce);

	for(int i = 0; i < P; i++)
	{
		coord bestCoords = checkCoords(animals[i], field, N, M);
		if(bestCoords.row == -1 || bestCoords.col == -1)
		{
			continue;
		}
		placeAnimal(bestCoords, animals[i], field);
		jumperCoords.push_back(bestCoords);
		jumperPosition.push_back(animals[i].position);
		animalsJumped++;
	}

	ofstream parashOut;
	parashOut.open("parash.out");

	parashOut<<animalsJumped;
	if(animalsJumped)
	{
		parashOut<<endl;
	}
	for(int i = 0; i < animalsJumped; i++)
	{

		parashOut<<jumperPosition[i]<<' '<<jumperCoords[i].row+1<<' '<<jumperCoords[i].col+1;
		if(i != animalsJumped-1)
		{
			parashOut<<endl;
		}
	}
	parashOut.close();

    return 0;
}
